/*
 * DevInterrupt.c
 *
 * Copyright 2008, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 *
 *Գס
 *
 *
 *
 *ԸƤ
 */


#include <sys/config.h>
#include <sys/types.h>
#include <sys/param.h>
#include <lib/lib.h>
#include <kern/Thread.h>
#include <kern/Wait.h>
#include <kern/vm.h>
#include <module/interrupt.h>
#include <i386/interrupt.h>
#include <i386/Entry.h>

#include <kern/debug.h>


//#define DEBUG_DEVINTERRUPT 1
#ifdef DEBUG_DEVINTERRUPT
	#define STATIC
	#define INLINE
#else
	#define STATIC	static
	#define INLINE	inline
#endif


//=====================================  ===================================================

//===================================== Х륤ݡ =======================================

//===================================== PRIVATE ====================================================

/*
 * return : task switch NO
 */
STATIC int defaultIntrHandler(int irq)
{
	printk("interrupt : %d\n", irq);
	return NO;
}

//===================================== PUBLIC =====================================================

/*
 * ͥߥϥɥơ֥
 * returns : task switch on 1,off 0
 */
int (*irq_entry[IRQ_ENTRY])(int) = {
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler,
	defaultIntrHandler
};

/*
 * Release hard interrupt mask
 * parameters : IRQ number
 */
void (*release_irq_mask)(uchar);

/*
 * Set hard interrupt mask
 * parameters : IRQ number
 */
void (*set_irq_mask)(uchar);

/*
 * ϡɳѣţϣɴؿ
 * parameters : IRQ number
 */
void (*irq_eoi)(uchar);

/*
 * ͥߥϥɥƤӽФ
 *Գ
 *ԸƤեƥࡦ桼֤η¬ˡ
 * return : task switch YES or NO
 */
int doKernIntrHandler(
	const int i_irq)		// IRQֹ
{
	int isTaskSwitch;

	// ߻
	calcTaskUserTime();
	setTaskCurrentTime();

	// ϥɥ顼ƤӽФ
	isTaskSwitch = irq_entry[i_irq](i_irq);

	// ߻
	calcTaskSysTime();
	setTaskCurrentTime();

	return isTaskSwitch;
}

/*
 * 桼ߥϥɥѥ᡼򥻥åȤ
 * return : user esp
 */
uint setUserIntrParam(
	const int i_irq)		// IRQֹ
{
	return vmSetModuleParam(
		getVmTask(IntrDscGetTask(i_irq)), 
		IntrDscGetReturnMethod(i_irq), 
		(uint) IntrDscGetArg(i_irq), 
		0, 0, 0, 0, 0);
}

/*
 * ɥ饤С˰ܹԤ
 * return : ڡǥ쥯ȥ
 */
void *switchDriverTask(
	const int i_irq)		// IRQֹ
{
	// 塼˥ɥ饤Сɲäܹ
	addScheduleDaemon(IntrDscGetTask(i_irq));

	// 桼⡼ɤɣľܤǤ褦ꤹ
	setUserModeIo();

	return switchTask();
}

/*
 * 桼ߥϥɥ򥻥åȤ
 */
void setUserIntrHandler(
	const int i_irq)		// IRQ
{
	ASSERT((0 <= i_irq) & (i_irq <= IRQ_ENTRY));

	// ϥɥƤӽФΥ桼å
	*(uint*) KERNEL_USER_ESP = DRIVER_ESP_BEG;
}

//*************************************************************************************************

#ifdef DEBUG
void startDevInterrupt()
{
	printk("UserIntrHandler ");
}

void endDevInterrupt()
{
	printk("end\n");
}
#endif
