/*
 * Entry.h
 *
 * Copyright 2008, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef i386_Entry_h
#define i386_Entry_h

#include <sys/config.h>
#include <sys/config.h>

#ifndef ASM_FILE

/*
 * ƥ
 */
typedef struct {
//	uint gs;
//	uint fs;
	uint ds;
	uint es;
	uint edi;
	uint esi;
	uint ebp;
	uint esp;
	uint ebx;
	uint edx;
	uint ecx;
	uint eax;
	uint error;
	uint eip;
	uint cs;
	uint eflags;
	uint user_esp;
	uint ss;
} TaskContext;

extern void startIdle();

extern void wait_task();
extern uint setChildContext(void*);
extern void saveStackEsp(void*);
extern void setExceptEntry(const int, void*);
extern void setExceptIntrEntry(const int, void*);
extern void setDevIntrEntry(const int, const int, void*);

extern int syscall();
extern int syscallModule();
extern void moduleInit();

extern void callUserHandler(void *, void *, const int);
extern void returnUserMethod();
extern void changeUserCall();

/*
 * 桼᥽åɥݥ󥿤ꤹ
 */
static inline void setUserRetrunMethod(
	void *i_returnMethod)		// ᥽åɥݥ
{
	*(void**) KERNEL_USER_RET = i_returnMethod;
}

/*
 * 桼᥽åɥݥ󥿤
 */
static inline void *getUserRetrunMethod()
{
	return *(void**) KERNEL_USER_RET;
}

#endif // ASM_FILE

#endif // i386_Entry_h
