/*
 * Wait.h
 *
 * Copyright 2008, Minoru Murashima. All rights reserved.
 * Distributed under the terms of the BSD License.
 */


#ifndef kern_Wait_h
#define kern_Wait_h

#include <sys/AggregateList.h>

#ifndef ASM_FILE

/*
 * ȹ¤
 *԰¸WaitΥƱ
 */
typedef struct {
	char dummy[sizeof(int) * 3];
} WaitObj;

typedef struct {
	AggregateList	aggregate;	// ȥꥹȥإå
	int volatile	refCount;	// 楫
	int				modify;		// ե饰
	int				gate;		// 楫ԥå
} MODIFY_WAIT_LOCK;

extern void waitTask();
extern void activeTask(WaitObj*);
extern void waitTaskSignal();
extern uint waitTimeSignal(const uint);
extern void activeTaskSignal(WaitObj*);
extern void activeTaskSoonSignal(WaitObj*);
extern void WaitIntr(WaitObj*, const uint);
extern int activeTaskIntr(WaitObj*);
extern void sleepTask(const int);
extern void wakeTask(WaitObj*, const int);
extern void wakeTaskSoon(WaitObj*, const int);
extern int exitSchedule();
extern int stopSchedule();
extern void initModifyWaitLock(MODIFY_WAIT_LOCK *);
extern void modifyWaitLock(MODIFY_WAIT_LOCK *modifyLock);
extern void modifyWaitUnlock(MODIFY_WAIT_LOCK *modifyLock);
extern void modifyWaitRef(MODIFY_WAIT_LOCK *modifyLock);
extern void modifyWaitRefEnd(MODIFY_WAIT_LOCK *modifyLock);

extern int sysTsleep();
extern int sysWakeup();
extern int sys_sleep();

#endif // ASM_FILE

#endif // kern_Wait_h
