/*
 * ⥸塼ᥤ
 */

#include <sys/types.h>
#include <sys/param.h>
#include <sys/device.h>
#include <sys/conf.h>
#include <errno.h>
#include <stdio.h>

extern struct cdevsw cons_cdevsw;

/*
 * Configure the system's hardware.
 */
static void configure(void)
{
	extern struct cfdriver *cfdriver_list_initial[];
	extern struct cfattachinit cfattachinit[];
	extern struct cfdata cfdata[];
	extern short cfroots[];
	extern struct cdevsw **cdevsw;
	extern int max_cdevsws;

	setInitialTable(cfdriver_list_initial, cfattachinit, cfdata, cfroots);
	setCdevsw(cdevsw);
	setMaxCdevsws(max_cdevsws);

	callout_startup();

	consinit();

	/* Initialize data structures. */
	config_init();

	/*
	 * Do the machine-dependent portion of autoconfiguration.  This
	 * sets the configuration machinery here in motion by "finding"
	 * the root bus.  When this function returns, we expect interrupts
	 * to be enabled.
	 */
	cpu_configure();
}

int main()
{
	int error;

	// ⥸塼
	if (initModule() != 0) {
		printf("initModue failed!\n");
		return 0;
	}

	// ǥХϿ
	configure();

	// ⥸塼Ͽ
	if (cdevsw_attach("console", &cons_cdevsw, cdevsw_lookup_major(&cons_cdevsw), getReturnMethod()) != 0) {
		printf("cdevsw_attach failed!\n");
		return 0;
	}

	// ꡼
	error = sleepModule();
	if (error != 0) {
		printf("Module sleep error! : %d\n", errno);
	}

	// ̥ץޤäƤʤ

	printf("Module was deleted\n");

	return 0;
}
